Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -1722,176 +1771,170 @@
  *      done_q_first = done queue first pointer.
  *      done_q_last  = done queue last pointer.
  */
-STATIC void
-qla1280_done(scsi_qla_host_t *ha, srb_t **done_q_first, srb_t **done_q_last)
-{
-    srb_t           *sp;
-    scsi_lu_t       *q;
-    uint32_t        b, t, l;
-    Scsi_Cmnd  *cmd;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-
-    ENTER("qla1280_done");
-    COMTRACE('D') 
-
-    DRIVER_LOCK 
-    while (*done_q_first !=  NULL)
-    {
-        /* remove command from done list */
-                sp = *done_q_first;
-        if (!(*done_q_first = sp->s_next))
-            *done_q_last = NULL;
-        else
-            (*done_q_first)->s_prev = NULL;
-                cmd = sp->cmd;
-        b = SCSI_BUS_32(cmd);
-        t = SCSI_TCN_32(cmd);
-        l = SCSI_LUN_32(cmd);
-        q = LU_Q(ha, b, t, l);
-
-        /* Decrement outstanding commands on device. */
-        if (q->q_outcnt)
-            q->q_outcnt--;
-        if (q->q_outcnt < ha->bus_settings[b].hiwat)
-        {
-            q->q_flag &= ~QLA1280_QBUSY;
-        }
-        
-        q->resp_time += jiffies - sp->r_start;                /* Lun bookkeeping information */
-        q->act_time += jiffies - sp->u_start;
-        q->io_cnt++;
-        if( sp->dir & BIT_5 )
-         q->r_cnt++;
-        else
-         q->w_cnt++;
-
-        switch ( (CMD_RESULT(cmd)>>16))
-        {
-            case DID_RESET:
-                q->q_flag &= ~QLA1280_QRESET;
-                /* Issue marker command. */
-                qla1280_marker(ha, b, t, 0, MK_SYNC_ID); 
-                break;
-            case DID_ABORT:
-                sp->flags &= ~SRB_ABORT_PENDING;
-                sp->flags |= SRB_ABORTED;
-                if (sp->flags & SRB_TIMEOUT)
-                    CMD_RESULT(sp->cmd)= DID_TIME_OUT << 16;
-                break;
-            default:
-                break;
-        }
-
-        /* Call the mid-level driver interrupt handler */
-        CMD_HANDLE(sp->cmd) = (unsigned char *) 0;
-        ha->actthreads--;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-        sti(); 
-        (*(cmd)->scsi_done)(cmd);
-        cli(); 
-#else
-        (*(cmd)->scsi_done)(cmd);
+static void
+qla1280_done(struct scsi_qla_host *ha, struct srb ** done_q_first,
+	     struct srb ** done_q_last)
+{
+	struct srb *sp;
+	int bus, target, lun;
+	Scsi_Cmnd *cmd;
+
+	ENTER("qla1280_done");
+
+	while (*done_q_first != NULL) {
+		/* remove command from done list */
+		sp = *done_q_first;
+		if (!(*done_q_first = sp->s_next))
+			*done_q_last = NULL;
+		else
+			(*done_q_first)->s_prev = NULL;
+
+		cmd = sp->cmd;
+		bus = SCSI_BUS_32(cmd);
+		target = SCSI_TCN_32(cmd);
+		lun = SCSI_LUN_32(cmd);
+
+		switch ((CMD_RESULT(cmd) >> 16)) {
+		case DID_RESET:
+			/* Issue marker command. */
+			qla1280_marker(ha, bus, target, 0, MK_SYNC_ID);
+			break;
+		case DID_ABORT:
+			sp->flags &= ~SRB_ABORT_PENDING;
+			sp->flags |= SRB_ABORTED;
+			if (sp->flags & SRB_TIMEOUT)
+				CMD_RESULT(sp->cmd) = DID_TIME_OUT << 16;
+			break;
+		default:
+			break;
+		}
+
+		/* Release memory used for this I/O */
+		if (cmd->use_sg) {
+			dprintk(3, "S/G unmap_sg cmd=%p\n", cmd);
+
+			pci_unmap_sg(ha->pdev, cmd->request_buffer,
+				     cmd->use_sg,
+				     scsi_to_pci_dma_dir(cmd->sc_data_direction));
+		} else if (cmd->request_bufflen) {
+			/*dprintk(1, "No S/G unmap_single cmd=%x saved_dma_handle=%lx\n",
+			  cmd, sp->saved_dma_handle); */
+
+			pci_unmap_page(ha->pdev, sp->saved_dma_handle,
+				       cmd->request_bufflen,
+				       scsi_to_pci_dma_dir(cmd->sc_data_direction));
+		}
+
+		/* Call the mid-level driver interrupt handler */
+		CMD_HANDLE(sp->cmd) = (unsigned char *)INVALID_HANDLE;
+		ha->actthreads--;
+
+#if LINUX_VERSION_CODE < 0x020500
+		if (cmd->cmnd[0] == INQUIRY)
+			qla1280_get_target_options(cmd, ha);
 #endif
-        qla1280_next(ha, q, b);
-    }
-    DRIVER_UNLOCK 
+		(*(cmd)->scsi_done)(cmd);
 
+		if(sp->wait != NULL)
+			complete(sp->wait);
 
-    COMTRACE('d') 
-    LEAVE("qla1280_done");
+	}
+	LEAVE("qla1280_done");
 }
 
 /*
  * Translates a ISP error to a Linux SCSI error
  */
-STATIC int qla1280_return_status( sts_entry_t *sts, Scsi_Cmnd       *cp)
+static int
+qla1280_return_status(struct response * sts, Scsi_Cmnd * cp)
 {
-    int host_status = DID_ERROR;
+	int host_status = DID_ERROR;
 #if DEBUG_QLA1280_INTR
-    STATIC char *reason[] =
-    {
-        "DID_OK",
-                "DID_NO_CONNECT",
-                "DID_BUS_BUSY",
-                "DID_TIME_OUT",
-                "DID_BAD_TARGET",
-                "DID_ABORT",
-                "DID_PARITY",
-                "DID_ERROR",
-                "DID_RESET",
-                "DID_BAD_INTR"
-    };
-#endif /* DEBUG_QLA1280_INTR */
+	static char *reason[] = {
+		"DID_OK",
+		"DID_NO_CONNECT",
+		"DID_BUS_BUSY",
+		"DID_TIME_OUT",
+		"DID_BAD_TARGET",
+		"DID_ABORT",
+		"DID_PARITY",
+		"DID_ERROR",
+		"DID_RESET",
+		"DID_BAD_INTR"
+	};
+#endif				/* DEBUG_QLA1280_INTR */
 
-    ENTER("qla1280_return_status");
+	ENTER("qla1280_return_status");
 
 #if DEBUG_QLA1280_INTR
-    /*
-    DEBUG(printk("qla1280_return_status: compl status = 0x%04x\n", sts->comp_status));
-    */
-#endif
-    switch(sts->comp_status)
-    {
-        case CS_COMPLETE:
-            host_status = DID_OK;
-            break;
-        case CS_INCOMPLETE:
-            if (!(sts->state_flags & SF_GOT_BUS))
-                host_status = DID_NO_CONNECT;
-            else if (!(sts->state_flags & SF_GOT_TARGET))
-                host_status = DID_BAD_TARGET;
-            else if (!(sts->state_flags & SF_SENT_CDB))
-                host_status = DID_ERROR;
-            else if (!(sts->state_flags & SF_TRANSFERRED_DATA))
-                host_status = DID_ERROR;
-            else if (!(sts->state_flags & SF_GOT_STATUS))
-                host_status = DID_ERROR;
-            else if (!(sts->state_flags & SF_GOT_SENSE))
-                host_status = DID_ERROR;
-            break;
-        case CS_RESET:
-            host_status = DID_RESET;
-            break;
-        case CS_ABORTED:
-            host_status = DID_ABORT;
-            break;
-        case CS_TIMEOUT:
-            host_status = DID_TIME_OUT;
-            break;
-        case CS_DATA_OVERRUN:
-#ifdef QL_DEBUG_LEVEL_2 
-            printk("Data overrun 0x%x\n",(int)sts->residual_length);
-            qla1280_print(
-                        "\n\rqla1280_isr: response packet data\n\r");
-                        qla1280_dump_buffer((caddr_t)sts,
-                        RESPONSE_ENTRY_SIZE); 
-#endif
-            host_status = DID_ERROR;
-            break;
-        case CS_DATA_UNDERRUN:
-            if ( (CMD_XFRLEN(cp) - sts->residual_length) < cp->underflow)    
-            { 
-              printk("scsi: Underflow detected - retrying command.\n");
-              host_status = DID_ERROR;
-            }
-            else
-                host_status = DID_OK;
-            break;
-        default:
-            host_status = DID_ERROR;
-            break;
-    }
+	/*
+	  dprintk(1, "qla1280_return_status: compl status = 0x%04x\n",
+	  sts->comp_status);
+	*/
+#endif
+	switch (sts->comp_status) {
+	case CS_COMPLETE:
+		host_status = DID_OK;
+		break;
+
+	case CS_INCOMPLETE:
+		if (!(sts->state_flags & SF_GOT_BUS))
+			host_status = DID_NO_CONNECT;
+		else if (!(sts->state_flags & SF_GOT_TARGET))
+			host_status = DID_BAD_TARGET;
+		else if (!(sts->state_flags & SF_SENT_CDB))
+			host_status = DID_ERROR;
+		else if (!(sts->state_flags & SF_TRANSFERRED_DATA))
+			host_status = DID_ERROR;
+		else if (!(sts->state_flags & SF_GOT_STATUS))
+			host_status = DID_ERROR;
+		else if (!(sts->state_flags & SF_GOT_SENSE))
+			host_status = DID_ERROR;
+		break;
+
+	case CS_RESET:
+		host_status = DID_RESET;
+		break;
+
+	case CS_ABORTED:
+		host_status = DID_ABORT;
+		break;
+
+	case CS_TIMEOUT:
+		host_status = DID_TIME_OUT;
+		break;
+
+	case CS_DATA_OVERRUN:
+		dprintk(2, "Data overrun 0x%x\n", sts->residual_length);
+		dprintk(2, "qla1280_isr: response packet data\n");
+		qla1280_dump_buffer(2, (char *)sts, RESPONSE_ENTRY_SIZE);
+		host_status = DID_ERROR;
+		break;
+
+	case CS_DATA_UNDERRUN:
+		if ((cp->request_bufflen - sts->residual_length) <
+		    cp->underflow) {
+			printk(KERN_WARNING
+			       "scsi: Underflow detected - retrying "
+			       "command.\n");
+			host_status = DID_ERROR;
+		} else
+			host_status = DID_OK;
+		break;
+
+	default:
+		host_status = DID_ERROR;
+		break;
+	}
 
 #if DEBUG_QLA1280_INTR
-    sprintf(debug_buff, "qla1280 ISP status: host status (%s) scsi status %x\n\r", reason[host_status], sts->scsi_status);
-    qla1280_print(debug_buff);
+	dprintk(1, "qla1280 ISP status: host status (%s) scsi status %x\n",
+		reason[host_status], sts->scsi_status);
 #endif
 
-    LEAVE("qla1280_return_status");
+	LEAVE("qla1280_return_status");
 
-    return (sts->scsi_status & 0xff) | (host_status << 16);
+	return (sts->scsi_status & 0xff) | (host_status << 16);
 }
 
 /*
@@ -1903,252 +1946,24 @@
  *      done_q_first = done queue first pointer.
  *      done_q_last  = done queue last pointer.
  */
-STATIC void
-qla1280_done_q_put(srb_t *sp, srb_t **done_q_first, srb_t **done_q_last)
-{
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_put_done_q");
-#endif
-    /* Place block on done queue */
-    DRIVER_LOCK
-            sp->s_next = NULL;
-    sp->s_prev = *done_q_last;
-    if (!*done_q_first)
-        *done_q_first = sp;
-    else
-        (*done_q_last)->s_next = sp;
-    *done_q_last = sp;
-
-    DRIVER_UNLOCK
-#ifdef QL_DEBUG_LEVEL_3
-            LEAVE("qla1280_put_done_q");
-#endif
-}
-
-/*
- * qla1280_next
- *      Retrieve and process next job in the queue.
- *
- * Input:
- *      ha = adapter block pointer.
- *      q  = SCSI LU pointer.
- *      b  = SCSI bus number.
- *      SCSI_LU_Q lock must be already obtained and no other locks.
- *
- * Output:
- *      Releases SCSI_LU_Q upon exit.
- */
-STATIC void
-qla1280_next(scsi_qla_host_t *ha, scsi_lu_t *q, uint8_t b)
-{
-    srb_t   *sp;
-    uint32_t cnt;
-    uint8_t status;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-
-    ENTER("qla1280_next");
-
-    DRIVER_LOCK
-    while ( ((sp = q->q_first) != NULL) &&     /* we have a queue pending */
-        !(q->q_flag &  QLA1280_QBUSY) &&      /* device not busy */
-        !ha->flags.abort_isp_active &&      /* not resetting the adapter */
-        !(q->q_flag & QLA1280_QSUSP) )      /* device not suspended */
-    {
-        /* Remove srb from SCSI LU queue. */
-        qla1280_removeq(q, sp);
-
-        DEBUG(sprintf(debug_buff,"starting request 0x%p<-(0x%p)\n\r",q,sp));
-        DEBUG(qla1280_print(debug_buff));
-        {
-            /* Set busy flag if reached high water mark. */
-            q->q_outcnt++;
-            if (q->q_outcnt >= ha->bus_settings[b].hiwat)
-                q->q_flag |= QLA1280_QBUSY;
-
-#if  QLA1280_64BIT_SUPPORT
-            if (ha->flags.enable_64bit_addressing)
-                status = qla1280_64bit_start_scsi(ha, sp);
-            else
-#endif
-                status = qla1280_32bit_start_scsi(ha, sp);
-
-            if (status)  /* if couldn't start the request */
-            {
-                if (q->q_outcnt == 1)
-                {
-                    /* Release SCSI LU queue specific lock */
-                    QLA1280_SCSILU_UNLOCK(q);
-
-                    /* Wait for 30 sec for command to be accepted. */
-                    for (cnt = 6000000; cnt; cnt--)
-                    {
-#if  QLA1280_64BIT_SUPPORT
-                        if (ha->flags.enable_64bit_addressing)
-                            status = qla1280_64bit_start_scsi(ha, sp);
-                        else
-#endif
-                            status = qla1280_32bit_start_scsi(ha, sp);
-
-                        if (!status)
-                        {
-                            break;
-                        }
-
-                        /* Go check for pending interrupts. */
-                        qla1280_poll(ha);
-
-                        SYS_DELAY(5);  /* 10 */
-                    }
-                    if (!cnt)
-                    {
-                        /* Set timeout status */
-                        CMD_RESULT(sp->cmd) = DID_TIME_OUT << 16;
-
-#if WATCHDOGTIMER
-                        /* Remove command from watchdog queue. */
-                        if (sp->flags & SRB_WATCHDOG)
-                            qla1280_timeout_remove(ha, sp);
-#endif
-                        COMTRACE('M') 
-                        CMD_HANDLE(sp->cmd) = (unsigned char *) 0;
-
-                        /* Call the mid-level driver interrupt handler */
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-                        sti(); 
-                        (*(sp->cmd)->scsi_done)(sp->cmd);
-                        cli(); 
-#else
-                        (*(sp->cmd)->scsi_done)(sp->cmd);
-#endif
-
-                        /* Acquire LU queue specific lock */
-                        QLA1280_SCSILU_LOCK(q);
-
-                        if (q->q_outcnt)
-                            q->q_outcnt--;
-                    }
-                    else
-                        /* Acquire LU queue specific lock */
-                        QLA1280_SCSILU_LOCK(q);
-                }
-                else
-                {   /* Place request back on top of device queue. */
-                    qla1280_putq_t(q, sp);
-
-                    if (q->q_outcnt)
-                        q->q_outcnt--;
-                    if (q->q_outcnt < ha->bus_settings[b].hiwat)
-                        q->q_flag &= ~QLA1280_QBUSY;
-                    break;
-                }
-            }
-        }
-    }
-   DRIVER_UNLOCK
-
-    /* Release SCSI LU queue specific lock */
-    QLA1280_SCSILU_UNLOCK(q);
-
-    LEAVE("qla1280_next");
-}
+static void
+qla1280_done_q_put(struct srb * sp, struct srb ** done_q_first,
+		   struct srb ** done_q_last)
+{
+	ENTER("qla1280_put_done_q");
+
+	/* Place block on done queue */
+	sp->s_next = NULL;
+	sp->s_prev = *done_q_last;
+	if (!*done_q_first)
+		*done_q_first = sp;
+	else
+		(*done_q_last)->s_next = sp;
+	*done_q_last = sp;
 
-/*
- * qla1280_putq_t
- *      Add the standard SCB job to the top of standard SCB commands.
- *
- * Input:
- *      q  = SCSI LU pointer.
- *      sp = srb pointer.
- *      SCSI_LU_Q lock must be already obtained.
- */
-STATIC void
-qla1280_putq_t(scsi_lu_t *q, srb_t *sp)
-{
-    srb_t *srb_p;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_putq_t");
-#endif
-    DRIVER_LOCK
-    DEBUG(sprintf(debug_buff,"Adding to device 0x%p<-(0x%p)\n\r",q,sp));
-    DEBUG(qla1280_print(debug_buff));
-    sp->s_next = NULL;
-    if (!q->q_first)                  /* If queue empty */
-    {
-        sp->s_prev = NULL;
-        q->q_first = sp;
-        q->q_last = sp;
-    }
-    else
-    {      
-        srb_p = q->q_first;
-        while (srb_p )
-            srb_p = srb_p->s_next;
-
-        if (srb_p)
-        {
-            sp->s_prev = srb_p->s_prev;
-            if (srb_p->s_prev)
-                srb_p->s_prev->s_next = sp;
-            else
-                q->q_first = sp;
-            srb_p->s_prev = sp;
-            sp->s_next = srb_p;
-        }
-        else
-        {
-            sp->s_prev = q->q_last;
-            q->q_last->s_next = sp;
-            q->q_last = sp;
-        }
-    }
-
-    DRIVER_UNLOCK
-#ifdef QL_DEBUG_LEVEL_3
-            LEAVE("qla1280_putq_t");
-#endif
+	LEAVE("qla1280_put_done_q");
 }
 
-/*
- * qla1280_removeq
- *      Function used to remove a command block from the
- *      LU queue.
- *
- * Input:
- *      q  = SCSI LU pointer.
- *      sp = srb pointer.
- *      SCSI_LU_Q lock must be already obtained.
- */
-STATIC void
-qla1280_removeq(scsi_lu_t *q, srb_t *sp)
-{
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-    DEBUG(sprintf(debug_buff,"Removing from device_q (0x%p)->(0x%p)\n\r",q,sp));
-    DEBUG(qla1280_print(debug_buff));
-    DRIVER_LOCK
-            if (sp->s_prev)
-    {
-        if ((sp->s_prev->s_next = sp->s_next) != NULL)
-            sp->s_next->s_prev = sp->s_prev;
-        else
-            q->q_last = sp->s_prev;
-    }
-    else if (!(q->q_first = sp->s_next))
-        q->q_last = NULL;
-    else
-        q->q_first->s_prev = NULL;
-    DRIVER_UNLOCK
-}
 
 /*
 * qla1280_mem_alloc
@@ -2158,44 +1973,44 @@
 *      0  = success.
 *      1  = failure.
 */
-STATIC uint8_t
-qla1280_mem_alloc(scsi_qla_host_t *ha)
+static int
+qla1280_mem_alloc(struct scsi_qla_host *ha)
 {
+	int status = 1;
+	dma_addr_t dma_handle;
 
-	uint8_t   status = 1;
-
-#ifdef QL_DEBUG_LEVEL_3
 	ENTER("qla1280_mem_alloc");
-#endif
 
-#ifdef DYNAMIC_MEM_ALLOC
-	ha->request_ring = qla1280_alloc_phys(REQUEST_ENTRY_SIZE * REQUEST_ENTRY_CNT,
-	&ha->request_dma);
-	if(ha->request_ring) {
-		ha->response_ring = qla1280_alloc_phys(RESPONSE_ENTRY_SIZE * RESPONSE_ENTRY_CNT,
-		&ha->response_dma);
-		if(ha->response_ring) {
-			status = 0;
-		}
-	}
-#else
-	ha->request_ring = &ha->req[0];
-	ha->request_dma = VIRT_TO_BUS(&ha->req[0]);
-	ha->response_ring = &ha->res[0];
-	ha->response_dma = VIRT_TO_BUS(&ha->res[0]);
+	/* get consistent memory allocated for request and response rings */
+	ha->request_ring = pci_alloc_consistent(ha->pdev,
+						((REQUEST_ENTRY_CNT + 1) *
+						 (sizeof(request_t))),
+						&dma_handle);
+	if (!ha->request_ring)
+		goto error;
+	ha->request_dma = dma_handle;
+	ha->response_ring = pci_alloc_consistent(ha->pdev,
+						 ((RESPONSE_ENTRY_CNT + 1) *
+						  (sizeof(struct response))),
+						 &dma_handle);
+	if (!ha->response_ring)
+		goto error;
+	ha->response_dma = dma_handle;
 	status = 0;
-#endif
+	goto finish;
 
-	if(status) {
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-		qla1280_print("qla1280_mem_alloc: **** FAILED ****\n");
-#endif
-	}
-#ifdef QL_DEBUG_LEVEL_3
-	else
-		LEAVE("qla1280_mem_alloc");
-#endif
-	return(status);
+ error:
+	if (status)
+		dprintk(2, "qla1280_mem_alloc: **** FAILED ****\n");
+
+	if (ha->request_ring)
+		pci_free_consistent(ha->pdev,
+                                    ((REQUEST_ENTRY_CNT + 1) *
+				     (sizeof(request_t))),
+                                    ha->request_ring, ha->request_dma);
+ finish:
+	LEAVE("qla1280_mem_alloc");
+	return status;
 }
 
 /*
@@ -2205,66 +2020,68 @@
  * Input:
  *      ha = adapter block pointer.
  */
-STATIC void
-qla1280_mem_free(scsi_qla_host_t *ha)
+static void
+qla1280_mem_free(struct scsi_qla_host *ha)
 {
-    scsi_lu_t *q;
-    uint32_t  b, t, l;
-
-    ENTER("qlc1280_mem_free");
-    if (ha)
-    {
-        /* Free device queues. */
-        for (b = 0; b < MAX_BUSES; b++)
-        {
-            q = LU_Q(ha, b, ha->bus_settings[b].id, 0);
-            for (t = 0; t < MAX_TARGETS; t++)
-                for (l = 0; l < MAX_LUNS; l++)
-                    if (LU_Q(ha, b, t, l) != NULL && LU_Q(ha, b, t, l) != q)
-                        KMFREE(LU_Q(ha, b, t, l),sizeof(struct scsi_lu));
-                    KMFREE(q, sizeof(struct scsi_lu));
-        }
-        for( b =0; b < MAX_EQ; b++ )
-            ha->dev[b] =  (scsi_lu_t  *)NULL;
-    }
+	ENTER("qlc1280_mem_free");
+	/* free consistent memory allocated for request and response rings */
+	if (ha->request_ring)
+		pci_free_consistent(ha->pdev,
+				    ((REQUEST_ENTRY_CNT + 1) *
+				     (sizeof(request_t))),
+				    ha->request_ring, ha->request_dma);
+
+	if (ha->response_ring)
+		pci_free_consistent(ha->pdev,
+				    ((RESPONSE_ENTRY_CNT + 1) *
+				     (sizeof(struct response))),
+				    ha->response_ring, ha->response_dma);
+
+	if (qla1280_buffer) {
+		free_page((unsigned long) qla1280_buffer);
+		qla1280_buffer = NULL;
+	}
 
-    LEAVE("qlc1280_mem_free");
+	LEAVE("qlc1280_mem_free");
 }
 
-
-
-
 /****************************************************************************/
 /*                QLogic ISP1280 Hardware Support Functions.                */
 /****************************************************************************/
 
  /*
- * qla2100_enable_intrs
- * qla2100_disable_intrs
- *
- * Input:
- *      ha = adapter block pointer.
- *
- * Returns:
- *      None      
- */
-    static inline void qla1280_enable_intrs(scsi_qla_host_t *ha) {
-        device_reg_t *reg;
-
-        reg = ha->iobase;
-        ha->flags.interrupts_on = 1;
-        /* enable risc and host interrupts */
-        WRT_REG_WORD(&reg->ictrl, (ISP_EN_INT+ ISP_EN_RISC));
-    }
-
-    static inline void qla1280_disable_intrs(scsi_qla_host_t *ha) {
-        device_reg_t *reg;
-
-        reg = ha->iobase;
-        ha->flags.interrupts_on = 0;
-        /* disable risc and host interrupts */
-        WRT_REG_WORD(&reg->ictrl, 0);
-    }
+    * qla2100_enable_intrs
+    * qla2100_disable_intrs
+    *
+    * Input:
+    *      ha = adapter block pointer.
+    *
+    * Returns:
+    *      None
+  */
+static inline void
+qla1280_enable_intrs(struct scsi_qla_host *ha)
+{
+	struct device_reg *reg;
+
+	reg = ha->iobase;
+	/* enable risc and host interrupts */
+	WRT_REG_WORD(&reg->ictrl, (ISP_EN_INT | ISP_EN_RISC));
+	RD_REG_WORD(&reg->ictrl);	/* PCI Posted Write flush */
+	ha->flags.ints_enabled = 1;
+}
+
+static inline void
+qla1280_disable_intrs(struct scsi_qla_host *ha)
+{
+	struct device_reg *reg;
+
+	reg = ha->iobase;
+	/* disable risc and host interrupts */
+	WRT_REG_WORD(&reg->ictrl, 0);
+	RD_REG_WORD(&reg->ictrl);	/* PCI Posted Write flush */
+	ha->flags.ints_enabled = 0;
+}
 
 /*
  * qla1280_initialize_adapter
@@ -2276,159 +2093,130 @@
  * Returns:
  *      0 = success
  */
-STATIC uint8_t
-qla1280_initialize_adapter(scsi_qla_host_t *ha)
+static int
+qla1280_initialize_adapter(struct scsi_qla_host *ha)
 {
-    device_reg_t *reg;
-    uint8_t      status;
-    /* uint8_t      cnt; */
-    uint8_t      b;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_initialize_adapter");
-#endif
-
-    /* Clear adapter flags. */
-    ha->flags.online = FALSE;
-    ha->flags.isp_abort_needed = FALSE;
-    ha->flags.disable_host_adapter = FALSE;
-    ha->flags.reset_active = FALSE;
-    ha->flags.abort_isp_active = FALSE;
-    ha->flags.watchdog_enabled = FALSE;
-
-    DEBUG(printk("Configure PCI space for adapter...\n"));
-    if (!(status = qla1280_pci_config(ha)))
-    {
-        reg = ha->iobase;
-
-        /* Disable ISP interrupts. */
-        WRT_REG_WORD(&reg->ictrl, 0);
-
-        /* Insure mailbox registers are free. */
-        WRT_REG_WORD(&reg->semaphore, 0);
-        WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
-        WRT_REG_WORD(&reg->host_cmd, HC_CLR_HOST_INT);
-
-        /* If firmware needs to be loaded */
-        if (qla1280_verbose)
-         printk("scsi(%d): Determining if RISC is loaded...\n",(int)ha->host_no);
-        if (qla1280_isp_firmware(ha))
-        {
-            if (qla1280_verbose)
-              printk("scsi(%d): Verifying chip...\n",(int)ha->host_no);
-            if (!(status = qla1280_chip_diag(ha)))
-            {
-                if (qla1280_verbose)
-                  printk("scsi(%d): Setup chip...\n",(int)ha->host_no);
-                status = qla1280_setup_chip(ha); 
-            }
-        }
-
-        if (!status)
-        {
-            /* Setup adapter based on NVRAM parameters. */
-            if (qla1280_verbose)
-              printk("scsi(%d): Configure NVRAM parameters...\n",(int)ha->host_no);
-            qla1280_nvram_config(ha);
-
-            if (!ha->flags.disable_host_adapter &&
-                !qla1280_init_rings(ha))
-            {
-                /* Issue SCSI reset. */
-                for (b = 0; b < ha->ports; b++)
-                    if (!ha->bus_settings[b].disable_scsi_reset)
-                    {
-                      /* dg 03/13 if we can't reset twice then bus is dead */
-                        if( qla1280_bus_reset(ha, b) )
-                           if( qla1280_bus_reset(ha, b) )
-                           {
-                               ha->bus_settings[b].scsi_bus_dead = TRUE;
-                            }
-                    }
-
-                    do
-                    {
-                        /* Issue marker command. */
-                        ha->flags.reset_marker = FALSE;
-                        for (b = 0; b < ha->ports; b++)
-                        {
-                            ha->bus_settings[b].reset_marker = FALSE;
-                            qla1280_marker(ha, b, 0, 0, MK_SYNC_ALL);
-                        }
-                    }while (ha->flags.reset_marker);
-
-                    ha->flags.online = TRUE;
-
-                    /* Enable host adapter target mode. */
-                    for (b = 0; b < ha->ports; b++)
-                    {
-                        if (!(status = qla1280_enable_tgt(ha, b)))
-                        {
-                            /* for (cnt = 0; cnt < MAX_LUNS; cnt++)
-                            {
-                                qla1280_enable_lun(ha, b, cnt);
-                                 qla1280_poll(ha);
-                            }*/
-                        }
-                        else
-                            break;
-                    }
-            }
-            else
-                status = 1;
-        }
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print("qla1280_initialize_adapter: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        LEAVE("qla1280_initialize_adapter");
+	struct device_reg *reg;
+	int status;
+	int bus;
+#if LINUX_VERSION_CODE > 0x020500
+	unsigned long flags;
+#endif
+
+	ENTER("qla1280_initialize_adapter");
+
+	/* Clear adapter flags. */
+	ha->flags.online = 0;
+	ha->flags.disable_host_adapter = 0;
+	ha->flags.reset_active = 0;
+	ha->flags.abort_isp_active = 0;
+
+	ha->flags.ints_enabled = 0;
+#if defined(CONFIG_IA64_GENERIC) || defined(CONFIG_IA64_SGI_SN2)
+	if (ia64_platform_is("sn2")) {
+		int count1, count2;
+		int c;
+
+		count1 = 3;
+		count2 = 3;
+		printk(KERN_INFO "scsi(%li): Enabling SN2 PCI DMA "
+		       "dual channel lockup workaround\n", ha->host_no);
+		if ((c = snia_pcibr_rrb_alloc(ha->pdev, &count1, &count2)) < 0)
+			printk(KERN_ERR "scsi(%li): Unable to allocate SN2 "
+			       "virtual DMA channels\n", ha->host_no);
+		ha->flags.use_pci_vchannel = 1;
+
+		driver_setup.no_nvram = 1;
+	}
 #endif
-    return(status);
-}
 
-/*
- * qla1280_enable_tgt
- *      Enable target mode.
- *
- * Input:
- *      ha = adapter block pointer.
- *      b  = SCSI bus number.
- *
- * Returns:
- *      0 = success.
- */
-STATIC uint8_t
-qla1280_enable_tgt(scsi_qla_host_t *ha, uint8_t b)
-{
-    uint8_t     status = 0;
-    /*  uint16_t    mb[MAILBOX_REGISTER_COUNT]; */
+	dprintk(1, "Configure PCI space for adapter...\n");
+
+	reg = ha->iobase;
+
+	/* Insure mailbox registers are free. */
+	WRT_REG_WORD(&reg->semaphore, 0);
+	WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
+	WRT_REG_WORD(&reg->host_cmd, HC_CLR_HOST_INT);
+	RD_REG_WORD(&reg->host_cmd);
+
+	if (qla1280_read_nvram(ha)) {
+		dprintk(2, "qla1280_initialize_adapter: failed to read "
+			"NVRAM\n");
+	}
+
+#if LINUX_VERSION_CODE >= 0x020500
+	/*
+	 * It's necessary to grab the spin here as qla1280_mailbox_command
+	 * needs to be able to drop the lock unconditionally to wait
+	 * for completion.
+	 * In 2.4 ->detect is called with the io_request_lock held.
+	 */
+	spin_lock_irqsave(HOST_LOCK, flags);
+#endif
+	/* If firmware needs to be loaded */
+	if (qla1280_isp_firmware(ha)) {
+		if (!(status = qla1280_chip_diag (ha))) {
+			status = qla1280_setup_chip(ha);
+		}
+	} else {
+		printk(KERN_ERR "scsi(%li): isp_firmware() failed!\n",
+		       ha->host_no);
+		status = 1;
+	}
+
+	if (status) {
+		printk(KERN_ERR "scsi(%li): initialize: pci probe failed!\n",
+		       ha->host_no);
+		goto out;
+	}
+
+	/* Setup adapter based on NVRAM parameters. */
+	dprintk(1, "scsi(%ld): Configure NVRAM parameters\n", ha->host_no);
+	qla1280_nvram_config(ha);
+
+	if (!ha->flags.disable_host_adapter && !qla1280_init_rings(ha)) {
+		/* Issue SCSI reset. */
+		/* dg 03/13 if we can't reset twice then bus is dead */
+		for (bus = 0; bus < ha->ports; bus++) {
+			if (!ha->bus_settings[bus].disable_scsi_reset){
+				if (qla1280_bus_reset(ha, bus)) {
+					if (qla1280_bus_reset(ha, bus)) {
+						ha->bus_settings[bus].scsi_bus_dead = 1;
+					}
+				}
+			}
+		}
 
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_enable_tgt: entered\n\r");
+		/*
+		 * qla1280_bus_reset() will take care of issueing markers,
+		 * no need to do that here as well!
+		 */
+#if 0
+		/* Issue marker command. */
+		ha->flags.reset_marker = 0;
+		for (bus = 0; bus < ha->ports; bus++) {
+			ha->bus_settings[bus].reset_marker = 0;
+			qla1280_marker(ha, bus, 0, 0, MK_SYNC_ALL);
+		}
 #endif
 
-    /* Enable target mode. */
-    /*
-    mb[0] = MBC_ENABLE_TARGET_MODE;
-    mb[1] = BIT_15;
-    mb[2] = (uint16_t)(b << 15);
-    status = qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0, &mb[0]);
-    */
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print("qla1280_enable_tgt: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_enable_tgt: exiting normally\n\r");
+		ha->flags.online = 1;
+	} else
+		status = 1;
+
+ out:
+#if LINUX_VERSION_CODE >= 0x020500
+	spin_unlock_irqrestore(HOST_LOCK, flags);
 #endif
-    return(status);
+	if (status)
+		dprintk(2, "qla1280_initialize_adapter: **** FAILED ****\n");
+
+	LEAVE("qla1280_initialize_adapter");
+	return status;
 }
 
+
 /*
  * ISP Firmware Test
  *      Checks if present version of RISC firmware is older than
